// This code belongs to Kurioos iTech.
//
// You have only the rights to install and use it with WoozTalk Instant
// Messenger. You are not allowed to distribute it, as is or updated.
// However, if you want to improve it or make derivative works, you are welcome
// to contact us and send us your suggestions (and your code). If we like them,
// we may include your ideas in the next update and you will be credited for
// them.
//
// I apologize for the quality of this code ... I don't like very much
// javascript and XUL ...... :-p

// Variables globales
var gSites = new Array();
var undefined; // Just in case ...
var nbrTab = 1;
var connection_status = -1;  // 0 : no client available, 1 : client available but not connected, 2 : client connected
var bundle = undefined;

var wooztalkPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);

var isActive = HasToSendURL();

function HasToSendURL() 
{
    if (wooztalkPrefs.getPrefType("wooztalkonfirefox.enabled") != wooztalkPrefs.PREF_BOOL) {
	wooztalkPrefs.setBoolPref("wooztalkonfirefox.enabled", true);
	return true;
    } else {
	return wooztalkPrefs.getBoolPref("wooztalkonfirefox.enabled");
    }
}

function SetHasToSendURL(st)
{
    LOG("SetHasToSendURL START");
    wooztalkPrefs.setBoolPref("wooztalkonfirefox.enabled", st);
    LOG("SetHasToSendURL END");
}

function countWindows()
{
    LOG("countWindows START");
    var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
	.getService(Components.interfaces.nsIWindowMediator);
    var enumerator = wm.getEnumerator("navigator:browser");
    var counter = 0;
    LOG("Count !");
    while(enumerator.hasMoreElements())
    {
	var win = enumerator.getNext();
	counter = counter + 1;
    }
    LOG("countWindows END");
    return counter;
}

/* Display messages */
function LOG(msg) {
/*    var consoleService = Components.classes["@mozilla.org/consoleservice;1"]
	.getService(Components.interfaces.nsIConsoleService);
    consoleService.logStringMessage(msg);*/
}

/* Get string according to locale */
function getBundleString(key)
{
    if (bundle == undefined) {
	bundle = document.getElementById("firefoxonwooztalk-strings");
	LOG("load bundle : "+bundle);
	if (bundle == undefined) {
	    LOG("undefined");
	    return "";
	} else {
	    return bundle.getString(key);
	}
    } else {
	return bundle.getString(key);
    }
}

/* Store old site for a tab */
function setOldSiteURL(where, url)
{
    LOG("setOldSiteURL");
    if (nbrTab == 1) {
	onlyOneURL = url;
    } else {
	where.setAttribute("firefoxonwooztalk-old-site", url);
    }
}

/* Get old site for a tab */
function getOldSiteURL(where)
{
    LOG("getOldSiteURL");
    if (nbrTab == 1) {
	return onlyOneURL;
    } else {
	try {
	    return where.getAttribute("firefoxonwooztalk-old-site");
	} catch (e) {
	    return "";
	}
    }
}

/* Verify an URL and returns the one to use (empty string if this URL is not
 * allowed */
function verifyURL(url)
{
    try {
	LOG("Verif ("+url+") : "+url.host+" / "+url.host.indexOf("localhost")
		+ " / "+url.port+" / "+url.host.indexOf(":"));
	if (url.port != undefined && url.port != -1  && url.port != ""
		&& url.host.indexOf(":") == -1) {
	    port = ":"+url.port
	} else {
	    port = "";
	}

	if (url.scheme != undefined) {
	    if (url.scheme == "about") {
		return "";
	    } else if (url.scheme == "file") {
		return "";
	    } else if (url.scheme == "https"){
		return "http://"+url.host+port;
	    } else {
		return url.scheme+"://"+url.host+port;
	    }
	} else if (url.protocol != undefined) {
	    if (url.protocol == "https:") {
		return "http://"+url.host+port;
	    } else if (url.protocol == "file:") {
		return "";
	    } else {
		return url.protocol+"//"+url.host+port;
	    }
	} else {
	    LOG("Undefined scheme and protocol");
	    return "";
	}
    } catch (e) {
	LOG("Exception triggered");
	return "";
//	return url.scheme+"://"+url.host;
    }
}

/* Close all sites for current window */
function closeAllSites(sync)
{
    var num = getBrowser().browsers.length;
    for (var i = 0; i < num; i++) {
	var b = getBrowser().getBrowserAtIndex(i);
	try {
	    url = verifyURL(b.currentURI);
	    LOG(url);
	    if (url != "") {
		sendCloseURL(url, sync);
	    }
	} catch(e) {
	    Components.utils.reportError(e);
	}
    }
}

/* Open all sites for current window */
function openAllSites()
{
    var num = getBrowser().browsers.length;
    for (var i = 0; i < num; i++) {
	LOG("Browser "+i);
	var b = getBrowser().getBrowserAtIndex(i);
	try {
	    url = verifyURL(b.currentURI);
	    LOG(url);
	    if (url != "") {
		sendOpenURL(url);
	    }
	} catch(e) {
	    Components.utils.reportError(e);
	}
    }
}

function enableExtension()
{
    if (isActive) {
	// Nothing to do
	return ;
    } else {
	isActive = true;
	updateText(getBundleString("enabled"));

	var button = document.getElementById('firefoxonwooztalk-button');
	var statbutton = document.getElementById('firefoxonwooztalk-statusbar-button');

	statbutton.setAttribute('src',
	       	"chrome://firefoxonwooztalk/skin/enabled.ico");
	button.removeAttribute('mode');
	button.setAttribute('tooltiptext', 
		getBundleString("status.disable"));
	openAllSites();
    }
}

function disableExtension()
{
    if (!isActive) {
	// Nothing to do
	return ;
    } else {
	updateText(getBundleString("disabled"));

	var button = document.getElementById('firefoxonwooztalk-button');
	var statbutton = document.getElementById('firefoxonwooztalk-statusbar-button');

	statbutton.setAttribute('src', "chrome://firefoxonwooztalk/skin/disabled.ico");
	button.setAttribute('mode', 'disabled');
	button.setAttribute('tooltiptext', getBundleString("status.enable"));
	closeAllSites(false);
	isActive = false;
    }
}

var firefoxonwooztalk = {
  onLoad: function() { },
  onUnload: function() { },
  onMenuItemCommand: function(e) { },
  onToolbarButtonCommand: function(e) {
      LOG("onToolbarButtonCommand START");
      if (isActive) {
	  disableExtension();
	  alert(getBundleString("extension.disabled"));
      } else {
	  enableExtension();
      }
      LOG("onToolbarButtonCommand END");
  }
};

function addButtons() 
{
    LOG("addButtons ENTER");
    var navBar = document.getElementById("nav-bar");
    var newSet = "";
    var buttonsExist = false;

    // Check if buttons exist
    for(var k = 0; k < navBar.childNodes.length; k++) {
      if(navBar.childNodes[k].id == "firefoxonwooztalk-button") {
        buttonsExist = true;
      }
    }

    for(var k = 0; k < navBar.childNodes.length; k++) {
	if(navBar.childNodes[k].id == "firefoxonwooztalk-button") {
	    navBar.removeChild(navBar.childNodes[k]);
	    k--;
	}
    }

    //    if (!buttonsExist) {
    for(var k = 0; k < navBar.childNodes.length; k++) {
	if(navBar.childNodes[k].id == "urlbar-container") {
	    newSet += "firefoxonwooztalk-button,";
	}
	newSet += navBar.childNodes[k].id + ",";
    }

    newSet = newSet.substring(0, newSet.length - 1);
    navBar.currentSet = newSet;
    navBar.setAttribute("currentset", newSet);
    document.persist(navBar.id, "currentset");

    LOG("Init");
    var button = document.getElementById('firefoxonwooztalk-button');
    var statbutton = document.getElementById('firefoxonwooztalk-statusbar-button');
    var nbr = document.getElementById('firefoxonwooztalk-statusbar-nbr');

    if (isActive) {
	updateText(getBundleString("enabled"));
	statbutton.setAttribute('src',
	       	"chrome://firefoxonwooztalk/skin/enabled.ico");
	button.removeAttribute('mode');
	button.setAttribute('tooltiptext', 
		getBundleString("status.disable"));
    } else {
	updateText(getBundleString("disabled"));
	statbutton.setAttribute('src', "chrome://firefoxonwooztalk/skin/disabled.ico");
	button.setAttribute('mode', 'disabled');
	button.setAttribute('tooltiptext', getBundleString("status.enable"));
    }
	

    LOG("Customize done");
    try {
	BrowserToolboxCustomizeDone(true);
    } catch (e) {
    }

    LOG("Leave");
}

function callInProgress(xmlhttp) {
    switch ( xmlhttp.readyState ) {
	case 1, 2, 3:
	    return true;
	    break;

	    // Case 4 and 0
	default:
	    return false;
	    break;
    }
}

function sendOpenURL(url)
{
    if (!isActive) {
	LOG("EXTENSION IS NOT ACTIVE");
	return ;
    }

    LOG("OPEN_URL ("+url+ ")");
    var p = new XMLHttpRequest();
    var timeoutId = 
	window.setTimeout(
		function() {
		if (callInProgress(p)) {
		p.abort();
		LOG("Request aborted : "+url);
		}
		},
		1000 // One second
		);
    p.onreadystatechange = function() {
	LOG("OPEN_URL ("+url+ ") : "+p.readyState);
	if(p.readyState == 4) {
	    LOG("Response : "+p.responseText);
	    if (p.responseText == "") {
		gSites[url] = -2;
	    } else {
		gSites[url] = p.responseText;
	    }
	    updateNbr(url);
	}
    };
    p.onerror = function(e) {
	if (callInProgress(p)) {
	    p.abort();
	    LOG("Request aborted : "+url);
	}
	connection_status = 0;
    }
    p.open("GET", "http://localhost:6788/"+url, true);
    p.send(null);
}

function sendCloseURL(url, sync)
{
    if (!isActive) {
	LOG("EXTENSION IS NOT ACTIVE");
	return ;
    }

    try {
	LOG("CLOSE_URL : "+url);
	var p = new XMLHttpRequest();
	var timeoutId = 
	    window.setTimeout(
		    function() {
		    if (callInProgress(p)) {
		    p.abort();
		    LOG("Request aborted : "+url);
		    }
		    },
		    1000 // One second
		    );
	if (!sync) {
	    p.onreadystatechange = function() {
		LOG("CLOSE_URL ("+url+ ") : "+p.readyState);
	    };
	    p.onerror = function(e) {
		if (callInProgress(p)) {
		    p.abort();
		    LOG("Request aborted : "+url);
		}
		connection_status = 0;
	    }
	}
	p.open("GET", "http://localhost:6788/CLOSE:"+url, !sync);
	p.send(null);
    } catch (e) {
    }
}

function sendAskURL(url)
{
    if (!isActive) {
	LOG("EXTENSION IS NOT ACTIVE");
	return ;
    }

    LOG("ASK_URL : "+url);
    var p = new XMLHttpRequest();
    var timeoutId = 
	window.setTimeout(
		function() {
		if (callInProgress(p)) {
		p.abort();
		LOG("Request aborted : "+url);
		gSites[url] = -2;
		}
		},
		1000 // One second
		);
    p.onreadystatechange = function() {
	LOG("ASK_URL ("+url+") : " +p.readyState);
	if(p.readyState == 4) {
	    if (p.responseText == "") {
		gSites[url] = -2;
	    } else {
		gSites[url] = p.responseText;
	    }
	    updateNbr(url);
	}
    };
    p.onerror = function(e) {
	if (callInProgress(p)) {
	    p.abort();
	    LOG("Request aborted : "+url);
	}
	connection_status = 0;
    }
    p.open("GET", "http://localhost:6788/ASK:"+url, true);
    p.send(null);
}

/* Update nbr displayed in status bar for an URL */
function updateNbr(url)
{
    var currentHost =
	verifyURL(getBrowser().getBrowserAtIndex(getBrowser().mTabContainer.selectedIndex).currentURI);

    LOG("UPDATE : "+url+"/"+currentHost);
    var nbr = document.getElementById('firefoxonwooztalk-statusbar-nbr');
    if (isActive == false) {
	nbr.value = getBundleString("disabled");
    } else if (url == currentHost) {
	LOG("UPDATE : "+url+"<="+gSites[url]);
	if (connection_status == 0) {
	    nbr.value =  getBundleString("notreachable");
	} else if (connection_status == 1) {
	    nbr.value =  getBundleString("clientnotconnected");
	} else if (gSites[url] == undefined) {
	    nbr.value =  getBundleString("noinfo");
	} else if (gSites[url] == -2) {
	    nbr.value =  getBundleString("notreachable");
	} else if (gSites[url] == -10) {
	    nbr.value = getBundleString("forbidden");
	} else if (gSites[url] == -11) {
	    nbr.value = getBundleString("blocked");
	} else if (gSites[url] == -12) {
	    nbr.value = getBundleString("noforlocal");
	} else if (gSites[url] == 0) {
	    nbr.value = getBundleString("nobody");
	} else if (gSites[url] == 1) {
	    nbr.value = gSites[url]+" "+getBundleString("wooztalker");
	} else {
	    nbr.value = gSites[url]+" "+getBundleString("wooztalkers");
	}
    }
}

function updateText(txt)
{
    var nbr = document.getElementById('firefoxonwooztalk-statusbar-nbr');
    LOG("text : "+nbr);
    if (nbr != undefined) {
	nbr.value = txt;
    }
}

function tabAdded(event)
{
    LOG("Tab added");
    if (nbrTab == 1) {
	var fbrowser = getBrowser().getBrowserAtIndex(0);
	fbrowser.addEventListener("pagehide", examplePageUnload, true);
	fbrowser.addEventListener("pageshow", examplePageLoad, true);
    }
    nbrTab++;

    var browser = event.target.linkedBrowser;
    browser.addEventListener("pagehide", examplePageUnload, true);
    browser.addEventListener("pageshow", examplePageLoad, true);
}

function tabRemoved(event)
{
    var browser = event.target.linkedBrowser;
    LOG("Tab removed : "+browser.currentURI);
    nbrTab--;

    browser.removeEventListener("pagehide", examplePageUnload, true);
    browser.removeEventListener("pageshow", examplePageLoad, true);

    var url = verifyURL(browser.currentURI);
    if (url=="") {
	return ;
    }

    LOG("Tab removed : "+url);
    sendCloseURL(url, false);
}

function tabSelected(event)
{
    LOG("Tab Selected");
    var browser = event.target.linkedBrowser;
    LOG("Tab Selected 2");
    if (browser.currentURI) {
	var url = verifyURL(browser.currentURI);
	if (url=="") {
	    updateText(getBundleString("noinfo"));
	    LOG("Tab Selected (end1)");
	    return ;
	}

	LOG("Sélection : "+url);
	updateNbr(url);
	sendAskURL(url);
    }
    LOG("Tab Selected (end)");
}

function examplePageUnload(event)
{
    LOG("examplePageUnload");
    if (event.originalTarget instanceof HTMLDocument) {
	var doc = event.originalTarget;
	if (event.originalTarget.defaultView.frameElement) {
	    return;
	}

	if (event.originalTarget.location == "about:blank") {
	    setOldSiteURL(this, "");
	    return ;
	}
	var url = verifyURL(event.originalTarget.location);
	LOG("examplePageUnload:"+url);
	if (url=="") {
	    setOldSiteURL(this, "");
	    return ;
	}

	// Store old site
	LOG("Page quittée : "+url);
	setOldSiteURL(this, url);
	LOG("Enregistré : "+getOldSiteURL(this));
    }
}


function examplePageLoad(event)
{
    LOG("examplePageLoad");
    if (event.originalTarget instanceof HTMLDocument) {
	var doc = event.originalTarget;
	if (event.originalTarget.defaultView.frameElement) {
	    return;
	}

	if (event.originalTarget.location == "about:blank") {
	    return ;
	}

	var url = verifyURL(event.originalTarget.location);
	var oldURL = getOldSiteURL(this);

	// Same site, nothing to do
	if (oldURL == url) {
	    LOG("On reste sur le même site");
	} else { // Close old site and send new one
	    if (oldURL != "") {
		sendCloseURL(oldURL, false);
	    }
	    sendOpenURL(url);
	}
    }
}

/* Check if client is available and connected */
function check_wooztalk_client_status()
{
    LOG("Check");
    var p = new XMLHttpRequest();
    var timeoutId = 
	window.setTimeout(
		function() {
		LOG("CHECK: timeout");
		if (callInProgress(p)) {
		p.abort();
		connection_status = 0;
		updateText(getBundleString("notreachable"));
		LOG("CHECK: again (timeout)");
		window.setTimeout(check_wooztalk_client_status, 10000);
		}
		},
		1000
		);
    p.onreadystatechange = function() {
	LOG("CHECK state "+p.readyState);
	if(p.readyState == 4) {
	    if (p.responseText != "") {
		LOG("isActive="+isActive+"  connection_status="+connection_status);
		if (isActive && connection_status == 0) {
		    openAllSites();
		}
		LOG("Switch : "+p.responseText);
		if (p.responseText[0] == "1") {
		    if (connection_status != 2) {
			updateText(getBundleString("reachable"));
			connection_status = 2;
		    }
		} else {
		    if (connection_status != 1) {
			updateText(getBundleString("clientnotconnected"));
			connection_status = 1;
		    }
		}
	    } else {
		if (connection_status != 0) {
		    connection_status = 0;
		    updateText(getBundleString("notreachable"));
		}
	    }
	    LOG("CHECK: again (normal)");
	    clearTimeout(timeoutId);
	    window.setTimeout(check_wooztalk_client_status, 10000);
	}
    };
    p.open("GET", "http://localhost:6788/CHECK:firefox", true);
    p.send(null);
}

function unregister_wooztalk()
{
    var p = new XMLHttpRequest();
    p.open("GET", "http://localhost:6788/QUIT:firefox", false);
    p.send(null);
}


window.addEventListener("pageshow",
	function (event) {
	if (nbrTab == 1) {
	LOG("general pageshow : "+event.originalTarget.location);
	this.examplePageLoad(event);
	}
	}, false);

window.addEventListener("pagehide",
	function (event) {
	if (nbrTab == 1) {
	LOG("general pagehide "+event.originalTarget.location);
	this.examplePageUnload(event);
	}
	}, false);


/* Ouverture d'une nouvelle fenêtre */
window.addEventListener( "load",
	function () {

	LOG("WoozTalk Launch !");

	var container = getBrowser().tabContainer;
	container.addEventListener("TabOpen", tabAdded, false);
	container.addEventListener("TabSelect", tabSelected, false);
	container.addEventListener("TabClose", tabRemoved, false);

	addButtons();

	LOG("Ready");
	}, false);

/* Window is closed */
window.addEventListener( "unload",
	function () {

	LOG("WoozTalk unload !");

	/* Close all sites */
	closeAllSites(true);

	var container = getBrowser().tabContainer;
	container.removeEventListener("TabOpen", tabAdded, false);
	container.removeEventListener("TabSelect", tabSelected, false);
	container.removeEventListener("TabClose", tabRemoved, false);

	SetHasToSendURL(isActive);

	LOG("Windows");
	if (countWindows() == 0) {
	  unregister_wooztalk();
	}

	LOG("WoozTalk Finish (unload) !");
	return false;
	}, false);


if (countWindows() == 1) {
    check_wooztalk_client_status();
}
